{
    FreeWinRally - Un programma per ricevere via packet i tempi dei rally
    Copyright (C) 2000, 2001, 2002 Sezione ARI Casale Monferrato & I1EPJ

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
}

unit Fogli;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, Config, Printers, UPrev, EdFoglio;

type
  TFFogli = class(TForm)
	 ElencoFogli: TListBox;
	 BitBtn1: TBitBtn;
	 BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;
    BitBtn6: TBitBtn;
    BitBtn7: TBitBtn;
    BitBtn8: TBitBtn;
    BitBtn9: TBitBtn;
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
	 procedure BitBtn3Click(Sender: TObject);
	 procedure FormCreate(Sender: TObject);
	 procedure AggiornaLista;
    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
    procedure BitBtn6Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BitBtn7Click(Sender: TObject);
    procedure ElencoFogliClick(Sender: TObject);
    procedure BitBtn8Click(Sender: TObject);
  	 procedure BitBtn9Click(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FFogli: TFFogli;
  TotFogli: integer;

implementation

uses rally;

{$R *.DFM}


procedure TFFogli.BitBtn1Click(Sender: TObject);

begin
	FFogli.Visible := False;
	TotFogli := FileSize(Quaderno);
	FillChar(Foglio, SizeOf(Foglio), 0);
   if TotFogli > 0 then begin
       Seek(Quaderno, TotFogli-1);
       Read(Quaderno, Foglio);
	end;
	FRally.VisualizzaFoglio(Foglio);
end;


procedure TFFogli.BitBtn2Click(Sender: TObject);

var Foglio: TFoglio;
	 NumRecord: longint;

begin
	if FileSize(Quaderno) > 0 then begin
		NumRecord := ElencoFogli.ItemIndex;
       if NumRecord >= 0 then begin
			Seek(Quaderno, NumRecord);
			Read(Quaderno,Foglio);
			FRally.VisualizzaFoglio(Foglio);
       end;
	end;
end;

procedure TFFogli.BitBtn3Click(Sender: TObject);

var Foglio: TFoglio;
	 NumRecord: longint;

begin
	if FileSize(Quaderno) > 0 then begin
		NumRecord := ElencoFogli.ItemIndex;
		Seek(Quaderno, NumRecord);
		Read(Quaderno,Foglio);
		if not Printer.Printing then begin
			BitBtn3.Caption := 'in corso...';
			FRally.StampaFoglio(Foglio,False,False);
			BitBtn3.Caption := 'Stampa';
			if not Foglio.Stampato then begin
					Foglio.Stampato := TRUE;
					Seek(Quaderno, NumRecord);
					Write(Quaderno,Foglio);
			end;
			AggiornaLista;
		end else begin
			Ret := Application.MessageBox(
				'Stampa precedente ancora in corso',
				'Attenzione!', MB_OK+MB_ICONSTOP+MB_DEFBUTTON1);
		end;
	end;
end;

procedure TFFogli.AggiornaLista;

var s: string;
	 pr: char;
    Foglio: TFoglio;

begin
	ElencoFogli.Clear;
   FillChar(Foglio, Sizeof(Foglio), 0);
	if FileSize(Quaderno) > 0 then begin
		Seek(Quaderno,0);
		while not eof(Quaderno) do begin
			Read(Quaderno, Foglio);
			if Foglio.Stampato then pr := '' else pr := ' ';
			s := Format('PS %2d Foglio %2d (%s)', [Foglio.PSNum, Foglio.FoglioNum, pr]);
			ElencoFogli.Items.Add(s);
		end;
       TotFogli := FileSize(Quaderno);
	end;
end;

procedure TFFogli.FormCreate(Sender: TObject);

begin
	if FileSize(Quaderno) > 0 then begin
		AggiornaLista;
		FRally.VisualizzaFoglio(Foglio);
	end;
end;

procedure TFFogli.BitBtn4Click(Sender: TObject);

var Foglio: TFoglio;
	 NumRecord: longint;

begin
	if FileSize(Quaderno) > 0 then begin
		NumRecord := ElencoFogli.ItemIndex;
		Seek(Quaderno, NumRecord);
      	Read(Quaderno,Foglio);
		if not Printer.Printing then begin
			BitBtn4.Caption := 'in corso...';
			FRally.StampaFoglio(Foglio,True,False);
			BitBtn4.Caption := 'StampaM';
			if not Foglio.Stampato then begin
					Foglio.Stampato := TRUE;
					Seek(Quaderno, NumRecord);
					Write(Quaderno,Foglio);
			end;
			AggiornaLista;
		end else begin
			Ret := Application.MessageBox(
				'Stampa precedente ancora in corso',
				'Attenzione!', MB_OK+MB_ICONSTOP+MB_DEFBUTTON1);
		end;
	end;
end;

procedure TFFogli.BitBtn5Click(Sender: TObject);

var NumRecord: integer;
	 Foglio: TFoglio;

begin
	NumRecord := ElencoFogli.ItemIndex;
	if FileSize(Quaderno) > 0 then begin
       if NumRecord >= 0 then begin
			Seek(Quaderno, NumRecord);
			Read(Quaderno, Foglio);
       end;
	end;
   FRally.VisualizzaFoglio(Foglio);
	if Conf.AutoPrintI = 0 then begin
   	{ stampa senza medie }
		FRally.StampaFoglio(Foglio, False, True);
   end else begin
   	{ stampa con medie }
       FRally.StampaFoglio(Foglio, True, True);
   end;
  	Preview.Show;
end;


procedure TFFogli.BitBtn6Click(Sender: TObject);

var NumRecord,n: integer;
	 FineFile: boolean;
    Foglio: TFoglio;

begin
	TotFogli := FileSize(Quaderno);
	if TotFogli > 0 then begin
		NumRecord := ElencoFogli.ItemIndex;
		if NumRecord > -1 then begin
		for n := NumRecord+1 to TotFogli-1 do begin
			Seek(Quaderno, n);
  	         	Read(Quaderno, Foglio);
			Seek(Quaderno, n-1);
  	        	Write(Quaderno, Foglio);
		end;
		Seek(Quaderno,TotFogli-1);
		Truncate(Quaderno);
        end;
   end;
   AggiornaLista;
   FRally.CostruisciMenuPS;
   if NumRecord < TotFogli then
      	ElencoFogli.ItemIndex := NumRecord
   else
      	ElencoFogli.ItemIndex := TotFogli - 1;
end;

procedure TFFogli.FormClose(Sender: TObject; var Action: TCloseAction);

begin
	BitBtn2.Enabled := False;
	BitBtn3.Enabled := False;
	BitBtn4.Enabled := False;
	BitBtn5.Enabled := False;
	BitBtn6.Enabled := False;
	BitBtn7.Enabled := False;
	BitBtn8.Enabled := False;

	FFogli.Hide;
	TotFogli := FileSize(Quaderno);
	FillChar(Foglio, SizeOf(Foglio), 0);
   if TotFogli > 0 then begin
       Seek(Quaderno, TotFogli-1);
       Read(Quaderno, Foglio);
	end;
	FRally.VisualizzaFoglio(Foglio);
end;

procedure TFFogli.BitBtn7Click(Sender: TObject);

var NumRecord, n: integer;

begin
	if FileSize(Quaderno) > 0 then begin
		with EditFoglio.EdTempi do begin
		end;
		NumRecord := ElencoFogli.ItemIndex;
		if NumRecord >= 0 then begin
			Seek(Quaderno, NumRecord);
			Read(Quaderno,Foglio);
			Fmtstr(s, 'Modifica PS %d Foglio %d', [Foglio.PSNum,Foglio.FoglioNum]);
      		EditFoglio.Caption := s;
			with EditFoglio.PSFoglio do begin
				Fmtstr(s, '%d', [Foglio.PSNum]);
				Cells[0,1] := s;
				Fmtstr(s, '%d', [Foglio.FoglioNum]);
				Cells[1,1] := s;
				Fmtstr(s, '%d', [Foglio.NumTempi]);
				Cells[2,1] := s;
			end;
			for n := 1 to Foglio.NumTempi do begin
				s := Format('%d',[Foglio.Tempi[n].Numero]);
				EditFoglio.EdTempi.Cells[0,n] := s;
				Fmtstr(s, '%2.2d', [Foglio.Tempi[n].Tempo.Minuti]);
				EditFoglio.EdTempi.Cells[1,n] := s;
				Fmtstr(s, '%2.2d', [Foglio.Tempi[n].Tempo.Secondi]);
				EditFoglio.EdTempi.Cells[2,n] := s;
				if Conf.TimeFormatI < 2 then begin
					Fmtstr(s, '%1.1d', [Foglio.Tempi[n].Tempo.Centesimi]);
               end else begin
					Fmtstr(s, '%2.2d', [Foglio.Tempi[n].Tempo.Centesimi]);
               end;
				EditFoglio.EdTempi.Cells[3,n] := s;
				EditFoglio.EdTempi.Cells[4,n] := Foglio.Tempi[n].Note;
			end;
			EditFoglio.EdNote.Cells[0,0] := Foglio.Note[1];
			EditFoglio.EdNote.Cells[0,1] := Foglio.Note[2];
			EditFoglio.Show;
           EditFoglio.Refresh;
       end;
       NuovoFoglio := FALSE;
   end;
end;

procedure TFFogli.ElencoFogliClick(Sender: TObject);
begin
	BitBtn2.Enabled := True;
	BitBtn3.Enabled := True;
	BitBtn4.Enabled := True;
	BitBtn5.Enabled := True;
	BitBtn6.Enabled := True;
	BitBtn7.Enabled := True;
   if CronoPortNameI >= 0 then BitBtn8.Enabled := True;
end;


procedure TFFogli.BitBtn8Click(Sender: TObject);

var NumRecord: integer;

begin
	NumRecord := ElencoFogli.ItemIndex;
	if NumRecord >= 0 then begin
		Seek(Quaderno, NumRecord);
		Read(Quaderno,Foglio);
   	FRally.VisualizzaFoglio(Foglio);
  		FRally.InviaFoglioAiCrono(Foglio);
   end;
end;

procedure TFFogli.BitBtn9Click(Sender: TObject);
begin
   NuovoFoglio := TRUE;;
   EditFoglio.Show;
end;

end.
